<?php

namespace App\Http\Controllers;

use App\Models\Feriado;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Request;

class FeriadoController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index(): JsonResponse
    {
        $items = Feriado::all();

        return response()->json([
            'success' => true,
            'data' => $items,
            'message' => 'Registros obtenidos correctamente',
        ], 200);
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request): JsonResponse
    {
        $payload = $request->only((new Feriado())->getFillable());
        $feriado = Feriado::create($payload);

        return response()->json([
            'success' => true,
            'data' => $feriado,
            'message' => 'Registro creado correctamente',
        ], 201);
    }

    /**
     * Display the specified resource.
     */
    public function show(Feriado $feriado): JsonResponse
    {
        return response()->json([
            'success' => true,
            'data' => $feriado,
            'message' => 'Registro obtenido correctamente',
        ], 200);
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, Feriado $feriado): JsonResponse
    {
        $payload = $request->only((new Feriado())->getFillable());
        $feriado->update($payload);

        return response()->json([
            'success' => true,
            'data' => $feriado,
            'message' => 'Registro actualizado correctamente',
        ], 200);
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Feriado $feriado): JsonResponse
    {
        $feriado->delete();

        return response()->json([
            'success' => true,
            'message' => 'Registro eliminado correctamente',
        ], 200);
    }
}